POJ

来源:互联网 发布:淘宝代付可以用花呗吗 编辑:程序博客网 时间:2024/05/24 03:19

点击打开题目链接

Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 20747 Accepted: 11550

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006

[Submit]   [Go Back]   [Status]   [Discuss]


题目大意:将一个四位数的素数换成目标素数,每次只能换一个数字,每一步换完之后得到的仍是一个素数,并且得到的素数不能重复。求最小变换次数。

思路:首先求一遍素数。然后bfs不断枚举各位数字,满足要求的数字加入队列,直到得到结果。

附上AC代码:

#include<iostream>#include<cstdio>#include<queue>#include<cstring>using namespace std;int prime[10000];int vis[10000];int st, en;int T;struct node {int num, step;};//筛法求素数void is_prime(){int vis[10000];memset(vis, 0, sizeof(vis));for (int i = 2; i < 10000; i++){if (!vis[i]){prime[i] = 1;for (int j = i*i; j < 10000; j += i)vis[j] = 1;}}}void bfs() {queue<node>q;q.push(node{ st, 0 });vis[st] = 1;while (!q.empty()){node temp = q.front();if (temp.num == en) {cout << temp.step << endl;return;}q.pop();int un = temp.num % 10;//个位int de = temp.num % 100 / 10;//十位//枚举个位for (int i = 1; i <= 9; i += 2){int ans = temp.num - un + i;if (!vis[ans] && prime[ans] == 1){vis[ans] = 1;q.push(node{ ans,temp.step + 1 });}}//枚举十位for (int i = 0; i <= 9; i++){int ans = temp.num / 100 * 100 + i * 10 + un;if (!vis[ans] && prime[ans] == 1){vis[ans] = 1;q.push(node{ ans,temp.step + 1 });}}//枚举百位for (int i = 0; i <= 9; i++){int ans = temp.num / 1000 * 1000 + i * 100 + un + de * 10;if (!vis[ans] && prime[ans] == 1){vis[ans] = 1;q.push(node{ ans,temp.step + 1 });}}//枚举千位for (int i = 1; i <= 9; i++)//千位不为0{int ans = temp.num % 1000 + i * 1000;if (!vis[ans] && prime[ans] == 1){vis[ans] = 1;q.push(node{ ans,temp.step + 1 });}}}cout << "Impossible" << endl;return;}int main(){is_prime();ios::sync_with_stdio(false);cin >> T;while (T--){cin >> st >> en;memset(vis, 0, sizeof(vis));bfs();}//system("pause");return 0;}

原创粉丝点击